<template>
    <nav class="side-nav">
        <a
            class="router-link-active router-link-exact-active intro-x flex items-center pl-5 pt-4"
            @click="$router.push({name: 'admin.home'})"
        >
            <img
                class="w-8"
                :src="'/img/logo-light.png'"
            >
            <span class="text-white text-lg ml-3"> {{ $appName }} </span>
        </a>
        <div class="side-nav__divider my-6"></div>
        <ul>
            <li
                v-for="(menu, key) in computedSideMenu"
                :key="`sidebar-${key}`"
            >
                <a
                    href="javascript:;"
                    class="side-menu cursor-pointer"
                    :class="{
                        'menu--active menu--open': menu.active && menu.children,
                        'menu--active': menu.active && !menu.children,
                    }"
                    @click="tryNavigate(menu, key)"
                >
                    <div class="side-menu__icon">
                        <template
                            v-if="menu.icon === 'home'"
                        >
                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide"><path d="M3 9l9-7 9 7v11a2 2 0 01-2 2H5a2 2 0 01-2-2z"></path><polyline points="9 22 9 12 15 12 15 22"></polyline></svg>
                        </template>
                        <template
                            v-else
                        >
                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide"><rect x="3" y="3" width="18" height="18" rx="2" ry="2"></rect><line x1="9" y1="3" x2="9" y2="21"></line></svg>
                        </template>
                    </div>
                    <div class="side-menu__title">
                        {{ $t(menu.name) }}
                        <div
                            v-if="menu.children"
                            class="side-menu__sub-icon"
                            :class="{
                                'transform rotate-180': menu.active
                            }"
                        >
                            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide"><polyline points="6 9 12 15 18 9"></polyline></svg>
                        </div>
                    </div>
                </a>
                <ul
                    v-if="menu.active && menu.children"
                >
                    <li
                        v-for="(child, ckey) in menu.children"
                        :key="`menu-${key}-child-${ckey}`"
                    >
                        <a
                            class="side-menu cursor-pointer"
                            :class="{
                                'side-menu--active': child.route === $route.name
                            }"
                            @click="tryNavigate(child, key)"
                        >
                            <div class="side-menu__icon">
                                <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide"><polyline points="22 12 18 12 15 21 9 3 6 12 2 12"></polyline></svg>

                            </div>
                            <div class="side-menu__title relative">
                                {{ $t(child.name) }}
                                <template
                                    v-if="child.notification && typeof $notifications[child.notification] !== 'undefined' && $notifications[child.notification] > 0"
                                >
                                    <div
                                        class="absolute inset-y-0 right-2"
                                    >
                                        <span
                                            class="bg-red-500 rounded-full text-xs w-6 h-6 text-center text-white self-center align-middle flex justify-center items-center"
                                        >
                                            {{ $notifications[child.notification] }}
                                        </span>
                                    </div>
                                </template>
                            </div>
                        </a>
                    </li>
                </ul>
            </li>
        </ul>
    </nav>
</template>

<script setup>
import {ref, computed, onMounted} from "vue";
import sideMenu from "~/side-menu.js";
import {useRoute, useRouter} from "vue-router";
import {useAdminStore} from "~/stores/admin.js";

const $router = useRouter();
const $route = useRoute();
const $adminStore = useAdminStore();
const $admin = computed(() => {
    return $adminStore.account;
});
const $notifications = computed(() => {
    return $adminStore.notifications;
});
const isSuperAdmin = computed(() => {
    if (!$admin.value) return false;
    return String($admin.value.type) === String(1) || String($admin.value.type) === String(2);
});
const isDeveloper = computed(() => {
    if (!$admin.value) return false;
    return String($admin.value.type) === String(2);
});
const permissions = computed(() => {
    return $adminStore.permissions;
});

const activeKey = ref(null);

const computedSideMenu = computed(() => {
    let m = [];
    sideMenu.forEach((row, key) => {
        //Single level
        if (typeof row.children === 'undefined') {
            let can = false;
            if (row.permissions) {
                if (isSuperAdmin.value || isDeveloper.value) {
                    can = true;
                }

                if (!can) {
                    row.permissions.forEach(p => {
                        if (permissions.value.includes(p)) can = true;
                    });
                }
            } else {
                can = true;
            }

            if (can) {
                m.push({
                    ...row,
                    active: activeKey.value === key
                });
            }
        } else {
            let child = [];
            row.children.forEach(sub => {
                let can = false;
                if (sub.permissions) {
                    if (isSuperAdmin.value || isDeveloper.value) {
                        can = true;
                    }

                    if (!can) {
                        sub.permissions.forEach(p => {
                            if (permissions.value.includes(p)) can = true;
                        });
                    }
                } else {
                    can = true;
                }

                if (can) {
                    child.push(sub);
                }
            });

            if (child) {
                m.push({
                    ...row,
                    children: child,
                    active: activeKey.value === key || (child.find(r => $route.name === r.name))
                });
            }
        }
    });
    return m;
});

const tryNavigate = async (nav, k) => {
    if (nav.route) {
        await $router.push({name: nav.route});
    }

    activeKey.value = k;
};

onMounted(() => {
    let k = null;
    computedSideMenu.value.forEach((row, key) => {
        if (row.children) {
            row.children.forEach((sub, skey) => {
                if (sub.route === $route.name) {
                    k = key;
                }
            });
        } else {
            if (row.route === $route.name) {
                k = key;
            }
        }
    });

    activeKey.value = k;
});
</script>
